﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Threading.Tasks.Dataflow;

namespace ProducerConsumerApplication
{
    class Consumer
    {
        public async Task<int> ConsumerAsync(ISourceBlock<byte[]> SourceBlock)
        {
            int bytesProcessed = 0;
 
            while (await SourceBlock.OutputAvailableAsync())
            {
                byte[] data = SourceBlock.Receive();

                bytesProcessed += data.Length;
            }

            return bytesProcessed;
        }
    }
}
