﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Threading;
using System.IO;

namespace FileReadAysnc
{
    class Program
    {
        public static void Main()
        {
            byte[] FileData = new byte[1000];

            FileStream FS = new FileStream("c:\\projects\\InputData.txt", FileMode.Open, FileAccess.Read,
            FileShare.Read, 1024, FileOptions.Asynchronous);

            Console.WriteLine("To start async read press return.");
            Console.ReadLine();

            IAsyncResult result = FS.BeginRead(FileData, 0, FileData.Length, null, null);


            // Work being done while we wait on the async read.
            Console.WriteLine("\r\n");
            Console.WriteLine("Doing Some other work here. \r\n");
            Console.WriteLine("\r\n");

            //Calling EndRead will block the main thread until the async work has finished.
            int num = FS.EndRead(result);


            FS.Close();


            Console.WriteLine("Read {0}  bytes from the file. \r\n", num);
            Console.WriteLine("Is the async read completed - {0}. \r\n", result.IsCompleted.ToString());
            Console.WriteLine(BitConverter.ToString(FileData));

            Console.ReadLine();
        }
    }
}
